--///////////////////////////////////////////////////////////////////////////////////////////////////

--------------   Copyright (C) 2019 OIC_Digital Twins Inc.  ----------------------

--This model is modeled by  Digital Twins Inc. using component of the open source library created by AK-30, ANSYS and is covered by this license agreement. 

--This model was provided by  Digital Twins Inc. to METI as a social contribution. 
--This model including any updates, modifications, revisions, copies, and documentation are copyrighted works of the Digital Twins Inc. 

--THIS MODEL IS LICENSED TO YOU "AS IT IS" AND WITH NO WARRANTIES, EXPRESSED OR IMPLIED. ALL COMPANIES CONTRIBUTING TO THIS LIBRARY SPECIFICALLY DISCLAIM
-- ALL IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 
--  Digital Twins Inc  AND ALL COMPANIES  MUST NOT HAVE ANY RESPONSIBILITY FOR ANY DAMAGES, FINANCIAL OR LEGAL CLAIMS WHATEVER.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            | Kimitoshi Tsuji    2-19.11.13 Digital Twins Inc. |         | 
-- ----------------------------------------------------------------------------



library ieee ; 
use ieee.mechanical_systems.all ; 

entity r2f is 

-- generic (
--    r : real := 0.281 ) ; 


 port (
	quantity r: real := 0.281;
	terminal n1 : rotational_v ;
    terminal t1 : translational_v ) ;

begin
    assert r > 0.0
      report "Radius R must be > 0.0"
      severity error;

end entity r2f ;
architecture beh of  r2f is 

	quantity omg across trq through n1 to rotational_v_ref ; 
	quantity v across  frc through  translational_v_ref to t1;  

begin 


	trq == frc * r ; 
    v   == -omg * r ; 

end architecture ;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

-----------------------------------------------------------------------------------------------------------------------

--------------   Copyright (C) 2019 OIC_Digital Twins Inc.  ----------------------

--This model is modeled by  Digital Twins Inc. using component of the open source library created by AK-30, ANSYS and is covered by this license agreement. 

--This model was provided by  Digital Twins Inc. to METI as a social contribution. 
--This model including any updates, modifications, revisions, copies, and documentation are copyrighted works of the Digital Twins Inc. 

--THIS MODEL IS LICENSED TO YOU "AS IT IS" AND WITH NO WARRANTIES, EXPRESSED OR IMPLIED. ALL COMPANIES CONTRIBUTING TO THIS LIBRARY SPECIFICALLY DISCLAIM
-- ALL IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 
--  Digital Twins Inc  AND ALL COMPANIES  MUST NOT HAVE ANY RESPONSIBILITY FOR ANY DAMAGES, FINANCIAL OR LEGAL CLAIMS WHATEVER.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            | Kimitoshi Tsuji    2-19.11.13 Digital Twins Inc. |         | 
-- ----------------------------------------------------------------------------




LIBRARY IEEE;
USE IEEE.MECHANICAL_SYSTEMS.ALL;

---------- ENTITY DECLARATION ----------
ENTITY	rrc IS

       PORT (
			  QUANTITY CTL    : IN real  := 0.0;
              QUANTITY RRC    : IN real  := 90.0;-- N/(Kg*g)*10-4
              QUANTITY Weight_F : IN real  := 200.0;-- Weight Force
              QUANTITY force_Rolling_Resistance : OUT  Force  ;

 		TERMINAL f1: translational_V
       );

END ENTITY rrc;

---------- ARCHITECTURE DECLARATION arch_rrc ----------
ARCHITECTURE arch_rrc OF rrc IS

  	QUANTITY F_RR: Force ;--Drug Force by RRC [Nm]
	QUANTITY velocity ACROSS force THROUGH f1 TO translational_V_REF;

BEGIN

-- equation start --
--    F_RR == RRC*1.0e-4 * Weight_F * PHYS_GRAVITY;
	F_RR == RRC*1.0e-4 * Weight_F ;
    force_Rolling_Resistance == F_RR;
if CTL >0.0 use
	IF velocity'ABOVE(0.001) USE
	    force == F_RR;
	ELSE
	    force == 0.0;	   
   end use;
	ELSE
	    force == 0.0;
end use;

break on velocity'above(0.0) ; 

END ARCHITECTURE arch_rrc; 
---------- END VHDLAMS MODEL rrc ----------

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Angular Velocity Sensor                                  --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MECHANICAL_SYSTEMS.ALL;

ENTITY vm_rot IS
  PORT(
    QUANTITY omega: OUT ANGULAR_VELOCITY; 
    TERMINAL rot1: ROTATIONAL_V);
END ENTITY vm_rot;
ARCHITECTURE behav OF vm_rot IS
  QUANTITY omega_val ACROSS rot1 TO rotational_v_ref;
  QUANTITY phi: ANGLE;
BEGIN
  omega_val == omega;
  omega == phi'dot;
END ARCHITECTURE behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Torque Sensor                                            --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MECHANICAL_SYSTEMS.ALL;

ENTITY fm_rot IS
  PORT(
    QUANTITY torque : OUT TORQUE;
    TERMINAL rot1, rot2 : ROTATIONAL_V);
END ENTITY fm_rot;
ARCHITECTURE behav OF fm_rot IS
  QUANTITY omega_zero ACROSS m_val THROUGH rot1 TO rot2;
BEGIN
  m_val == torque;
  omega_zero == 0.0;
END ARCHITECTURE behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Mass                                                     --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MECHANICAL_SYSTEMS.ALL;

ENTITY mass_rot IS
  GENERIC(
    phi0  : ANGLE := 0.0;
    omega0 : ANGULAR_VELOCITY := 0.0);
  PORT(
        QUANTITY j : MOMENT_INERTIA := 1.0;
        TERMINAL rot1 : ROTATIONAL_V );
END ENTITY mass_rot;
ARCHITECTURE behav of mass_rot IS
  QUANTITY omega ACROSS m THROUGH rot1 TO rotational_v_ref;
  QUANTITY phi : ANGLE;
  QUANTITY acc : ANGULAR_ACCELERATION;
BEGIN
  IF (domain = quiescent_domain) USE
    phi == phi0;
    omega == omega0;
  ELSE
    phi'dot == omega;
    omega'dot == acc;
  END USE;
    m == j*acc;
END ARCHITECTURE behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Damper                                                   --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MECHANICAL_SYSTEMS.ALL;

ENTITY damp_rot IS
  PORT(
    QUANTITY damping : IN ANGULAR_DAMPING := 1.0;
    TERMINAL rot1, rot2 : ROTATIONAL_V);
END ENTITY damp_rot;
ARCHITECTURE beha OF damp_rot IS
  QUANTITY omega ACROSS m THROUGH rot1 TO rot2;
  QUANTITY phi : ANGLE;
BEGIN
  m == damping*omega;
  omega == phi'dot;
END ARCHITECTURE beha;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Multiplier                                               --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
ENTITY MUL IS
    GENERIC (TS : REAL := 0.0); 
    PORT (QUANTITY INPUT0,INPUT1 : IN REAL;
          QUANTITY VAL : OUT REAL);
END ENTITY MUL;
ARCHITECTURE behav OF MUL IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
    temp_val == INPUT0*INPUT1;
    VAL == temp_val'ZOH(TS);
END ARCHITECTURE;
--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Tire_Rotation IS
	PORT (
		TERMINAL tire_rot : ROTATIONAL_V;
		TERMINAL MRV_TR_PNT : ROTATIONAL_V;
		QUANTITY tire_I : IN REAL := 0.1;
		QUANTITY tire_power_rot_tire : OUT REAL 
	);
BEGIN 
END ENTITY Tire_Rotation;

ARCHITECTURE struct OF Tire_Rotation IS
	TERMINAL net_1 : ROTATIONAL_V;
	TERMINAL n0048 : ROTATIONAL_V;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
BEGIN
	vm_rot1 : ENTITY WORK.vm_rot(behav)
		PORT MAP ( rot1 => tire_rot, omega => Q_3 );

	fm_rot1 : ENTITY WORK.fm_rot(behav)
		PORT MAP ( rot2 => tire_rot, rot1 => net_1, torque => Q_5 );

	Inertia_o_Tire : ENTITY WORK.mass_rot(behav)
		GENERIC MAP ( omega0 => 0.0 , phi0 => 0.0 )
		PORT MAP ( rot1 => N0048, j => tire_I );

	fm_rot2 : ENTITY WORK.fm_rot(behav)
		PORT MAP ( rot2 => N0048, rot1 => tire_rot, torque => Q_4 );

	damp_rot1 : ENTITY WORK.damp_rot(beha)
		PORT MAP ( rot2 => net_1, rot1 => MRV_TR_PNT, damping => 10000.0 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input1 => Q_3 , input0 => Q_4 );

	tire_power_rot_tire == Q_2;
END ARCHITECTURE struct;
----------------------------------------------------------------------

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Force Sensor                                             --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MECHANICAL_SYSTEMS.ALL;

ENTITY fm_tr IS
  PORT(
    QUANTITY f : OUT FORCE; 
    TERMINAL tr1, tr2: TRANSLATIONAL_V);
END ENTITY fm_tr;
ARCHITECTURE behav OF fm_tr IS
  QUANTITY v_zero ACROSS f_val THROUGH tr1 TO tr2;
BEGIN
  f_val == f;
  v_zero == 0.0;
END ARCHITECTURE behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Velocity Sensor                                          --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MECHANICAL_SYSTEMS.ALL;

ENTITY vm_tr IS
  PORT(
    QUANTITY v : OUT VELOCITY;
    TERMINAL tr1: TRANSLATIONAL_V);
END ENTITY vm_tr;
ARCHITECTURE behav OF vm_tr IS
  QUANTITY v_val ACROSS tr1 TO translational_v_ref;
BEGIN
 v_val == v;
END ARCHITECTURE behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Tire_Translation IS
	PORT (
		TERMINAL Rollong_Resistance : TRANSLATIONAL_V;
		TERMINAL tire_trans : TRANSLATIONAL_V;
		TERMINAL MTV_TR_PNT : TRANSLATIONAL_V;
		QUANTITY tire_power_roll_tire : OUT REAL 
	);
BEGIN 
END ENTITY Tire_Translation;

ARCHITECTURE struct OF Tire_Translation IS
	TERMINAL n0022 : TRANSLATIONAL_V;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
BEGIN
	Dive_Force2 : ENTITY WORK.fm_tr(behav)
		PORT MAP ( tr2 => Rollong_Resistance, tr1 => N0022, f => Q_4 );

	Dive_Force : ENTITY WORK.fm_tr(behav)
		PORT MAP ( tr2 => N0022, tr1 => tire_trans, f => Q_6 );

	Speed_TireFace : ENTITY WORK.vm_tr(behav)
		PORT MAP ( tr1 => MTV_TR_PNT, v => Q_3 );

	Dive_Force1 : ENTITY WORK.fm_tr(behav)
		PORT MAP ( tr2 => MTV_TR_PNT, tr1 => N0022, f => Q_5 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input1 => Q_3 , input0 => Q_4 );

	tire_power_roll_tire == Q_2;
END ARCHITECTURE struct;
----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;

ENTITY TR_PNT IS
	PORT (
		TERMINAL MTV_TR_PNT : TRANSLATIONAL_V;
		TERMINAL MRV_TR_PNT : ROTATIONAL_V;
		QUANTITY Road_Load_Select_Switch : IN REAL := 0.0;
		QUANTITY myu : IN REAL := 0.0;
		QUANTITY M : IN REAL := 0.0;
		QUANTITY tire_I : IN REAL := 0.0;
		QUANTITY tire_r : IN REAL := 0.0 
	);
BEGIN 
END ENTITY TR_PNT;

ARCHITECTURE struct OF TR_PNT IS
	TERMINAL net_26 : TRANSLATIONAL_V;
	TERMINAL net_29 : TRANSLATIONAL_V;
	TERMINAL net_28 : ROTATIONAL_V;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
BEGIN
	Rotation_to_translation : ENTITY WORK.r2f(beh)
		PORT MAP ( t1 => net_29, n1 => net_28, r => tire_r );

	Caliculate_Rolling_resistance : ENTITY WORK.rrc(arch_rrc)
		PORT MAP ( f1 => net_26, force_rolling_resistance => Q_4 , weight_f => M , rrc => myu , ctl => Road_Load_Select_Switch );

	Tire_Rotation: ENTITY WORK.Tire_Rotation(struct)
		PORT MAP ( tire_rot => net_28, mrv_tr_pnt => MRV_TR_PNT, tire_I => tire_I , tire_power_rot_tire => Q_3 );

	Tire_Translation: ENTITY WORK.Tire_Translation(struct)
		PORT MAP ( rollong_resistance => net_26, tire_trans => net_29, mtv_tr_pnt => MTV_TR_PNT, tire_power_roll_tire => Q_2 );
END ARCHITECTURE struct;
----------------------------------------------------------------------


