--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Gain                                                     --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
ENTITY GAIN IS
    GENERIC (TS : REAL := 0.0); 
    PORT (QUANTITY INPUT : IN REAL := 0.0;
          QUANTITY KP : IN REAL := 1.0;
          QUANTITY VAL : OUT REAL);
END ENTITY GAIN;
ARCHITECTURE behav OF GAIN IS
BEGIN
	VAL == KP*INPUT'ZOH(TS);
END behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

-- ----------------------------------------------------------------------------
-- Copyright (C) 2004-2011 VDA/FAT
--
-- This model is a component of the open source library created by the VDA/FAT 
-- working group number 30 and is covered by this license agreement. This model
-- including any updates, modifications, revisions, copies, and documentation
-- are copyrighted works of the VDA/FAT. Use of this model indicates your
-- complete and unconditional acceptance of the terms and conditions set forth
-- in this license agreement.
--  
-- The VDA/FAT grants a non-exclusive license to use, reproduce, modify and
-- distribute this model under the condition, that:
-- (a) no fee or other consideration is charged for any distribution except 
--     compilations distributed in accordance with Section (d) of this license 
--     agreement;
-- (b) the comment text embedded in this model is included verbatim in each
--     copy of this model made or distributed by you, whether or not such
--     version is modified;
-- (c) any modified version must include a conspicuous notice that this model
--     has been modified and the date of modification; and
-- (d) any compilations sold by you that include this model must include a 
--     conspicuous notice that this model is available from the VDA/FAT in 
--     its original form at no charge.
--
-- THIS MODEL IS LICENSED TO YOU "AS IT IS" AND WITH NO WARRANTIES, EXPRESSED
-- OR IMPLIED. THE VDA/FAT AND ALL COMPANIES CONTRIBUTING TO THIS LIBRARY
-- SPECIFICALLY DISCLAIM ALL IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS
-- FOR A PARTICULAR PURPOSE. THE VDA/FAT AND ALL COMPANIES ORGANIZED WITHIN
-- MUST NOT HAVE ANY RESPONSIBILITY FOR ANY DAMAGES, FINANCIAL OR LEGAL CLAIMS 
-- WHATEVER.
-- ----------------------------------------------------------------------------
-- Literature:
-- Fritzson, P.: Object-Oriented Modeling and Simulation with Modelica 2.1
-- IEEE Press, 2004.
--  
-- Dependencies: 
-- --------------------------------------------------------------------
-- Logical Library         Design unit
-- --------------------------------------------------------------------
--
--
-- Author(s):
-- Joachim Haase 
--
-- Validator:
-- 
--
-- Source:
-- q_firstorder_vda.vhd
--
-- Development simulator:
-- SystemVision Professional 
--
-- Tested on: 
-- ------------------------------------------------------------------
-- Version  Simulator      Version   OS    Validator      Date
-- ------------------------------------------------------------------
-- 1.1      
--
--
-- Modification History:
-- ------------------------------------------------------------------
-- Version  Author            Date           Description
-- ------------------------------------------------------------------
--  1.1    Joachim Haase      2005/02/06     Original Version     
-- 
--
-- ----------------------------------------------------------------------------
-- $Version: 3.0.0 $
-- $Revision: 2627 $
-- $Date: 2010-12-20 19:11:06 +0100 (Mon, 20 Dec 2010) $
-- $Author: andre $
-- ----------------------------------------------------------------------------
	

--/**
--	
-- First Order Transfer Function Block.
-- The model defines a first order system Q_OUT(s) = K/(T*s+1.0)*Q_IN(s).
-- <p>Name and functionality in accordance with Modelica.</p>
-- 
-- @generic   K	 gain []
-- @generic   T	 time constant  [s]
-- 
-- @port      Q_IN	 input port
-- @port      Q_OUT	 output port
--	
-- @library   FUNDAMENTALS_VDA
-- @structure control_systems/basic
-- @test      basic_test
-- @reference Fritzson, P.: Object-Oriented Modeling and Simulation with Modelica 2.1
--            IEEE Press, 2004.
--
--*/					



 
entity Q_FIRSTORDER_VDA is
   generic  (
      K   : REAL := 1.0;
      T   : REAL := 1.0   -- time constant [s]
      );
   port     (
      quantity Q_IN  : in  REAL;
      quantity Q_OUT : out REAL   -- output port
      );
end entity Q_FIRSTORDER_VDA;

architecture BASIC of Q_FIRSTORDER_VDA is 
  constant NUM : REAL_VECTOR := (0 => K);
  constant DEN : REAL_VECTOR := (1.0, T);
begin
  Q_OUT == Q_IN'LTF(NUM, DEN);
end architecture BASIC;
-- ----------------------------------------------------------------------------
-- Copyright (C) 2004-2011 VDA/FAT
-- ----------------------------------------------------------------------------


--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Current Source                                           --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------

LIBRARY IEEE;
USE IEEE.MATH_REAL.MATH_2_PI;
USE IEEE.ELECTRICAL_SYSTEMS.ALL;
USE IEEE.MECHANICAL_SYSTEMS.ALL;

ENTITY I IS 
    PORT (QUANTITY I : IN CURRENT := 1.0; 
          QUANTITY AC_MAG : IN CURRENT := 1.0e-3;
          QUANTITY AC_PHASE : IN ANGLE := 0.0;
          TERMINAL p,m: ELECTRICAL);
END ENTITY I;
ARCHITECTURE behav OF I IS
    QUANTITY v ACROSS ic THROUGH p TO m;
    QUANTITY ac_spec : real SPECTRUM AC_MAG, MATH_2_PI*AC_PHASE/360.0;
BEGIN
    IF (domain = quiescent_domain) OR (domain = time_domain) USE
	  ic == I;
    ELSE
      ic == ac_spec;
    END USE;
END ARCHITECTURE behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY BLO_PNT IS
	PORT (
		TERMINAL EL_BLO_PNT : ELECTRICAL;
		QUANTITY P_CATH_CNT_blower_W : IN REAL := 0.0 
	);
BEGIN 
END ENTITY BLO_PNT;

ARCHITECTURE struct OF BLO_PNT IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
BEGIN
	gain22 : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , kp => 0.005 , input => P_CATH_CNT_blower_W );

	q_firstorder_vda3 : ENTITY WORK.q_firstorder_vda(basic)
		GENERIC MAP ( t => 1.0 , k => 1.0 )
		PORT MAP ( q_out => Q_2 , q_in => Q_3 );

	i2 : ENTITY WORK.i(behav)
		PORT MAP ( m => electrical_ref, p => EL_BLO_PNT, ac_phase => 0.0 , ac_mag => 0.001 , i => Q_2 );
END ARCHITECTURE struct;
----------------------------------------------------------------------

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Power                                                    --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MATH_REAL.ALL;

ENTITY pow IS
    GENERIC (TS : REAL := 0.0);
    PORT (QUANTITY INPUT : IN REAL;
          QUANTITY EXP : IN REAL := 1.0;
          QUANTITY VAL : OUT REAL);
END ENTITY pow;
ARCHITECTURE behav OF pow IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
  temp_val == INPUT**exp;
  VAL == temp_val'ZOH(TS);
END behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Multiplier                                               --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
ENTITY MUL IS
    GENERIC (TS : REAL := 0.0); 
    PORT (QUANTITY INPUT0,INPUT1 : IN REAL;
          QUANTITY VAL : OUT REAL);
END ENTITY MUL;
ARCHITECTURE behav OF MUL IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
    temp_val == INPUT0*INPUT1;
    VAL == temp_val'ZOH(TS);
END ARCHITECTURE;
--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY AC_PNT IS
	PORT (
		TERMINAL EL_AC_PNT : ELECTRICAL;
		QUANTITY V_BT_Hi_PNT_V : IN REAL := 0.0;
		QUANTITY P_CATH_CNT_aircon_W : IN REAL := 0.0 
	);
BEGIN 
END ENTITY AC_PNT;

ARCHITECTURE struct OF AC_PNT IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
BEGIN
	q_firstorder_vda1 : ENTITY WORK.q_firstorder_vda(basic)
		GENERIC MAP ( t => 1.0 , k => 1.0 )
		PORT MAP ( q_out => Q_3 , q_in => P_CATH_CNT_aircon_W );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , exp => -1.0 , input => V_BT_Hi_PNT_V );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input1 => Q_3 , input0 => Q_4 );

	i3 : ENTITY WORK.i(behav)
		PORT MAP ( m => electrical_ref, p => EL_AC_PNT, ac_phase => 0.0 , ac_mag => 0.001 , i => Q_2 );
END ARCHITECTURE struct;
----------------------------------------------------------------------

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Heat Flow Sensor                                         --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.THERMAL_SYSTEMS.ALL;

ENTITY tfm IS
  PORT(
    QUANTITY heat: OUT HEAT_FLOW;
    TERMINAL th1, th2: THERMAL);
END ENTITY tfm;
ARCHITECTURE behav OF tfm IS
  QUANTITY t_zero ACROSS h THROUGH th1 TO th2;
BEGIN
  t_zero == 0.0;
  h == heat;
END ARCHITECTURE behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Constant                                                 --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MATH_REAL.MATH_2_PI;

ENTITY CONST IS
    GENERIC (TS : REAL := 0.0); 
    PORT (QUANTITY CONST : IN REAL := 1.0;
          QUANTITY AC_MAG : REAL := 1.0e-3;
          QUANTITY AC_PHASE : REAL := 0.0;
          QUANTITY VAL : OUT REAL := 0.0);
END ENTITY CONST;
ARCHITECTURE behav OF CONST IS
    QUANTITY ac_spec : real SPECTRUM AC_MAG, MATH_2_PI*AC_PHASE/360.0;
BEGIN
    IF (domain = quiescent_domain) OR (domain = time_domain) USE
		val == const'ZOH(ts);
    ELSE
        val == ac_spec;
    END USE;
END ARCHITECTURE behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Thermometer                                              --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.THERMAL_SYSTEMS.ALL;

ENTITY thm IS
  PORT(
    QUANTITY temp: OUT TEMPERATURE;
    TERMINAL th1 : THERMAL);
END ENTITY thm;
ARCHITECTURE behav OF thm IS
  QUANTITY t ACROSS th1 TO thermal_ref;
BEGIN
  t == temp;
END ARCHITECTURE behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Temperature Source                                       --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.THERMAL_SYSTEMS.ALL;
USE IEEE.MECHANICAL_SYSTEMS.ALL;
USE IEEE.MATH_REAL.MATH_2_PI;

ENTITY t IS
  PORT(
    QUANTITY value : IN TEMPERATURE := 293.0;
    QUANTITY AC_MAG : IN TEMPERATURE := 1.0e-3;
    QUANTITY AC_PHASE : IN ANGLE := 0.0;
    TERMINAL th1 : THERMAL);
END ENTITY t;
ARCHITECTURE behav OF t IS
  QUANTITY t_val ACROSS h THROUGH th1 TO thermal_ref;
  QUANTITY ac_spec : real SPECTRUM AC_MAG, MATH_2_PI*AC_PHASE/360.0;
BEGIN
  IF (domain = quiescent_domain) OR (domain = time_domain) USE
    t_val == value;
  ELSE
    t_val == ac_spec;
  END USE;
END ARCHITECTURE behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Thermal Resistance                                       --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.THERMAL_SYSTEMS.ALL;

ENTITY rth IS
  PORT(
    QUANTITY k : IN THERMAL_RESISTANCE := 1.0;
    TERMINAL th1, th2 : THERMAL);
END ENTITY rth;

ARCHITECTURE behav OF rth IS
  QUANTITY t ACROSS h THROUGH th1 TO th2;
BEGIN
  t == h*k;
END ARCHITECTURE behav;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Thermometer                                              --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.THERMAL_SYSTEMS.ALL;

ENTITY thm IS
  PORT(
    QUANTITY temp: OUT TEMPERATURE;
    TERMINAL th1 : THERMAL);
END ENTITY thm;

ARCHITECTURE behav OF thm IS
  QUANTITY t ACROSS th1 TO thermal_ref;
BEGIN
  t == temp;
END ARCHITECTURE behav;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Heat Flow Sensor                                         --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.THERMAL_SYSTEMS.ALL;

ENTITY tfm IS
  PORT(
    QUANTITY heat: OUT HEAT_FLOW;
    TERMINAL th1, th2: THERMAL);
END ENTITY tfm;

ARCHITECTURE behav OF tfm IS
  QUANTITY t_zero ACROSS h THROUGH th1 TO th2;
BEGIN
  t_zero == 0.0;
  h == heat;
END ARCHITECTURE behav;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Heat Flow Source                                         --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.THERMAL_SYSTEMS.ALL;
USE IEEE.MECHANICAL_SYSTEMS.ALL;
USE IEEE.MATH_REAL.MATH_2_PI;

ENTITY h IS
  PORT(
    QUANTITY value : IN HEAT_FLOW := 1.0;
    QUANTITY AC_MAG : IN HEAT_FLOW := 1.0e-3;
    QUANTITY AC_PHASE : IN ANGLE := 0.0;
    TERMINAL th1, th2 : thermal);
END ENTITY h;

ARCHITECTURE behav OF h IS
  QUANTITY t ACROSS h_val THROUGH th1 TO th2;
  QUANTITY ac_spec : real SPECTRUM AC_MAG, MATH_2_PI*AC_PHASE/360.0;
BEGIN
  IF (domain = quiescent_domain) OR (domain = time_domain) USE
    h_val == value;
  ELSE
    h_val == ac_spec;
  END USE;
END ARCHITECTURE behav;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Thermal Capacitance                                      --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.THERMAL_SYSTEMS.ALL;

ENTITY cth IS
  PORT(
    QUANTITY c_th : IN THERMAL_CAPACITANCE := 1.0; 
    QUANTITY t0 : IN TEMPERATURE := 293.0;
    TERMINAL th1 : THERMAL);
END ENTITY cth;

ARCHITECTURE behav OF cth IS
  QUANTITY t ACROSS h THROUGH th1 TO thermal_ref;
  QUANTITY h_int : real := t0;
BEGIN
  IF (domain = quiescent_domain) USE
    h_int == t0 * c_th;
    t == t0;
  ELSE
    h_int'dot == h;
    t == h_int / c_th;
  END USE;
END ARCHITECTURE behav;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY HVAC_HeatCircuit IS
	PORT (
		TERMINAL Defroster_Temp_K : THERMAL;
		TERMINAL HVAC_Temp_K : THERMAL;
		TERMINAL Room_Temp_K : THERMAL;
		TERMINAL Def_HeatLoss : THERMAL;
		TERMINAL Wall_HeatLoss : THERMAL;
		TERMINAL Outlet_HeatLoss : THERMAL;
		QUANTITY DEF_to_Room_W : OUT REAL;
		QUANTITY HVAC_to_Def_W : OUT REAL;
		QUANTITY HVAC_to_Room_W : OUT REAL;
		QUANTITY Wall_Loss_W : OUT REAL;
		QUANTITY Def_GlassLoss_W : OUT REAL;
		QUANTITY Outlet_Loss_W : OUT REAL;
		QUANTITY Human_Heat_W : IN REAL := 0.0;
		QUANTITY Temp_Initial : IN REAL := 0.0;
		QUANTITY HeaterPower_Input : IN REAL := 0.0 
	);
BEGIN 
END ENTITY HVAC_HeatCircuit;

ARCHITECTURE struct OF HVAC_HeatCircuit IS
	TERMINAL net_73 : THERMAL;
	TERMINAL net_7 : THERMAL;
	TERMINAL net_1 : THERMAL;
	TERMINAL net_68 : THERMAL;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
BEGIN
	R_HVAC_DefToRoom : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_7, th1 => Defroster_Temp_K, k => 0.0165 );

	Temp3 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => Defroster_Temp_K, temp => Q_10 );

	R_HVAC_Defroster : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => Defroster_Temp_K, th1 => net_68, k => 0.0165 );

	Heat2 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => Outlet_HeatLoss, th1 => net_73, heat => Q_9 );

	h1 : ENTITY WORK.h(behav)
		PORT MAP ( th2 => Room_Temp_K, th1 => thermal_ref, ac_phase => 0.0 , ac_mag => 0.001 , value => Human_Heat_W );

	Water : ENTITY WORK.cth(behav)
		PORT MAP ( th1 => HVAC_Temp_K, t0 => Temp_Initial , c_th => 12600.0 );

	Temp2 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => HVAC_Temp_K, temp => Q_8 );

	R_HVAC_FootHeater : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_1, th1 => Room_Temp_K, k => 0.0165 );

	Heat3 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => Wall_HeatLoss, th1 => Room_Temp_K, heat => Q_7 );

	Heat4 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_68, th1 => HVAC_Temp_K, heat => Q_6 );

	Heater1 : ENTITY WORK.h(behav)
		PORT MAP ( th2 => HVAC_Temp_K, th1 => thermal_ref, ac_phase => 0.0 , ac_mag => 0.001 , value => HeaterPower_Input );

	Cabin_Air : ENTITY WORK.cth(behav)
		PORT MAP ( th1 => Room_Temp_K, t0 => Temp_Initial , c_th => 3172.054365 );

	Temp1 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => Room_Temp_K, temp => Q_5 );

	Heat5 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_1, th1 => HVAC_Temp_K, heat => Q_4 );

	Heat1 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => Def_HeatLoss, th1 => Defroster_Temp_K, heat => Q_3 );

	Heat6 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => Room_Temp_K, th1 => net_7, heat => Q_2 );

	Cabin_Outlet_Rth : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_73, th1 => Room_Temp_K, k => 0.0225 );

	DEF_to_Room_W == Q_2;
	Def_GlassLoss_W == Q_3;
	HVAC_to_Room_W == Q_4;
	HVAC_to_Def_W == Q_6;
	Wall_Loss_W == Q_7;
	Outlet_Loss_W == Q_9;
END ARCHITECTURE struct;
----------------------------------------------------------------------


--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Negator                                                  --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
ENTITY NEG IS
    GENERIC(TS : REAL := 0.0);
    PORT (QUANTITY INPUT : IN REAL;
          QUANTITY VAL : OUT REAL);
END ENTITY NEG;

ARCHITECTURE behav OF NEG IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
	temp_val == -INPUT;
	VAL == temp_val'ZOH(TS);
END ARCHITECTURE;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Maximum                                                  --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MATH_REAL.ALL;

ENTITY MAX IS
    GENERIC (TS : REAL := 0.0);
    PORT (QUANTITY INPUT0,INPUT1 : IN REAL;
          QUANTITY VAL : OUT REAL);
END ENTITY MAX;

ARCHITECTURE behav OF MAX IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
  temp_val == REALMAX(INPUT0,INPUT1);
  VAL == temp_val'ZOH(TS);
END behav;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Multiplier                                               --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
ENTITY MUL IS
    GENERIC (TS : REAL := 0.0); 
    PORT (QUANTITY INPUT0,INPUT1 : IN REAL;
          QUANTITY VAL : OUT REAL);
END ENTITY MUL;

ARCHITECTURE behav OF MUL IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
    temp_val == INPUT0*INPUT1;
    VAL == temp_val'ZOH(TS);
END ARCHITECTURE;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Summation                                                --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
ENTITY SUM IS
    GENERIC (TS : REAL := 0.0);
    PORT (QUANTITY INPUT0,INPUT1 : IN REAL;
          QUANTITY VAL : OUT REAL);
END ENTITY SUM;

ARCHITECTURE behav OF SUM IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
  temp_val == INPUT0 + INPUT1;
  VAL == temp_val'ZOH(TS);
END behav;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Sign                                                     --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MATH_REAL.ALL;

ENTITY sign IS
    GENERIC (TS : REAL := 0.0); 
    PORT (QUANTITY INPUT : IN REAL;
          QUANTITY AMPL : IN REAL := 1.0;
          QUANTITY VAL : OUT REAL);
END ENTITY sign;

ARCHITECTURE behav OF sign IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
  IF (INPUT >= 0.0) USE
    temp_val == AMPL;
  ELSE
    temp_val == -AMPL;
  END USE;
  VAL == temp_val'ZOH(TS);
END behav;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Power                                                    --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MATH_REAL.ALL;

ENTITY pow IS
    GENERIC (TS : REAL := 0.0);
    PORT (QUANTITY INPUT : IN REAL;
          QUANTITY EXP : IN REAL := 1.0;
          QUANTITY VAL : OUT REAL);
END ENTITY pow;

ARCHITECTURE behav OF pow IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
  temp_val == INPUT**exp;
  VAL == temp_val'ZOH(TS);
END behav;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Reciprocal Value                                         --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MATH_REAL.ALL;

ENTITY fktres IS
    GENERIC (TS : REAL := 0.0);
    PORT (QUANTITY INPUT : IN REAL;
          QUANTITY VAL : OUT REAL);
END ENTITY fktres;

ARCHITECTURE behav OF fktres IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
  IF (INPUT = 0.0) USE
	temp_val == 0.0;
  ELSE
	temp_val == (1.0/INPUT);
  END USE;
  VAL == temp_val'ZOH(TS);
END behav;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Rth_Jurges_kmh6 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_kmh6;

ARCHITECTURE struct OF Rth_Jurges_kmh6 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
BEGIN
	neg1 : ENTITY WORK.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_15 , input1 => 1.0e-06 , input0 => Port1 );

	Car_Speed_mps : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 0.277777777777778 , input0 => Q_15 );

	sum2 : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY WORK.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY WORK.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input => Q_7 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , input1 => Q_12 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_10 , input0 => Q_11 );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => 7.1 , input0 => Q_8 );

	HTC2_Jurges2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY WORK.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;

ENTITY Rth_Jurges_mps6 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_mps6;

ARCHITECTURE struct OF Rth_Jurges_mps6 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
BEGIN
	neg1 : ENTITY WORK.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 1.0e-06 , input0 => Port1 );

	sum2 : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY WORK.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY WORK.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input => Q_11 );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input1 => 7.1 , input0 => Q_12 );

	HTC2_Jurges2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_10 , input0 => Q_11 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => Q_8 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY WORK.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Memory                                                   --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
ENTITY MEMORY IS
    GENERIC (Y0 : REAL := 0.0; 
             TS : REAL := 0.0); 
    PORT (QUANTITY INPUT : IN REAL;
          QUANTITY VAL : OUT REAL);
END ENTITY MEMORY;

ARCHITECTURE sml_behav OF memory IS
--  COMPONENT sml_memory IS
--    PORT(
--      QUANTITY in_val : IN REAL;
--      QUANTITY out_val : OUT REAL);
--  END COMPONENT;

--  ATTRIBUTE sml_output : STRING;
--  ATTRIBUTE sml_output OF sml_memory : COMPONENT IS "VAL => out_val";

--  ATTRIBUTE sml_model : STRING;
--  ATTRIBUTE sml_model OF sml_memory : COMPONENT IS "INTERN  GAIN  GAIN1   ( INPUT:=in_val,KP:=1,TS:=0) ;";
BEGIN
--  mem1 : sml_memory PORT MAP (in_val => input, out_val => val);

-- TF@07/15/12 as long as sml attribute doesn't work
  IF (DOMAIN = QUIESCENT_DOMAIN) USE
    VAL == Y0;
  ELSIF (DOMAIN = TIME_DOMAIN) USE
    IF (NOW < TS) USE
      VAL == Y0;
    ELSE
      VAL == INPUT'DELAYED(TS);
    END USE;
  ELSE
      VAL == INPUT'DELAYED(TS);
  END USE;

END ARCHITECTURE sml_behav;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Rth_radiation15 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation15;

ARCHITECTURE struct OF Rth_radiation15 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY WORK.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Rth_radiation16 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation16;

ARCHITECTURE struct OF Rth_radiation16 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY WORK.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Gain                                                     --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
ENTITY GAIN IS
    GENERIC (TS : REAL := 0.0); 
    PORT (QUANTITY INPUT : IN REAL := 0.0;
          QUANTITY KP : IN REAL := 1.0;
          QUANTITY VAL : OUT REAL);
END ENTITY GAIN;

ARCHITECTURE behav OF GAIN IS
BEGIN
	VAL == KP*INPUT'ZOH(TS);
END behav;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Roof IS
	PORT (
		TERMINAL QT_Outer : THERMAL;
		TERMINAL QT_Inner : THERMAL;
		QUANTITY Body_U : IN REAL := 0.0;
		QUANTITY Body_Cp : IN REAL := 0.0;
		QUANTITY Body_Weight : IN REAL := 0.0;
		QUANTITY Body_Area : IN REAL := 0.0;
		QUANTITY T0_init : IN REAL := 0.0;
		QUANTITY Vair_mps : IN REAL := 0.0;
		QUANTITY Vcar_kmh : IN REAL := 0.0;
		QUANTITY Heat_Outer_w : OUT REAL;
		QUANTITY Heat_Inner_w : OUT REAL;
		QUANTITY Tsurf_Inner : OUT REAL;
		QUANTITY Tcenter : OUT REAL;
		QUANTITY Tsurf_Outer : OUT REAL;
		QUANTITY HSTEP : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Roof;

ARCHITECTURE struct OF Roof IS
	TERMINAL net_20 : THERMAL;
	TERMINAL net_14 : THERMAL;
	TERMINAL net_27 : THERMAL;
	TERMINAL net_26 : THERMAL;
	TERMINAL net_21 : THERMAL;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
	QUANTITY Q_16 : real := 0.0;
	QUANTITY Q_17 : real := 0.0;
	QUANTITY Q_18 : real := 0.0;
	QUANTITY Q_19 : real := 0.0;
	QUANTITY Q_20 : real := 0.0;
	QUANTITY Q_21 : real := 0.0;
	QUANTITY Q_22 : real := 0.0;
	QUANTITY Q_23 : real := 0.0;
	QUANTITY Q_24 : real := 0.0;
	QUANTITY Q_25 : real := 0.0;
	QUANTITY Q_26 : real := 0.0;
	QUANTITY Q_27 : real := 0.0;
	QUANTITY Q_28 : real := 0.0;
BEGIN
	tfm2 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_26, th1 => QT_Inner, heat => Q_28 );

	tfm1 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => QT_Outer, th1 => net_21, heat => Q_27 );

	thm3 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_27, temp => Q_23 );

	thm1 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_14, temp => Q_26 );

	thm2 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_20, temp => Q_22 );

	thm4 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Outer, temp => Q_21 );

	thm5 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Inner, temp => Q_15 );

	SubSheet3: ENTITY WORK.Rth_Jurges_kmh6(struct)
		PORT MAP ( Port3 => Q_25 , Port1 => Vcar_kmh , Port2 => Q_9 );

	SubSheet4: ENTITY WORK.Rth_Jurges_mps6(struct)
		PORT MAP ( Port3 => Q_24 , Port1 => Vair_mps , Port2 => Q_7 );

	Body_HeatMass : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Body_Weight , input0 => Body_Cp );

	mul68 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Body_Area -- Expression
		, input0 => Body_U );

	memory4 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_14 , input => Q_23 );

	memory1 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_19 , input => Q_22 );

	memory2 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_20 , input => Q_21 );

	SubSheet2: ENTITY WORK.Rth_radiation15(struct)
		PORT MAP ( Port4 => Q_18 , Port3 => Q_17 , Port2 => Q_19 , Port1 => Q_20 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_16 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_17 );

	rth4 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_21, th1 => net_20, k => Q_16 );

	memory3 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_13 , input => Q_15 );

	SubSheet1: ENTITY WORK.Rth_radiation16(struct)
		PORT MAP ( Port4 => Q_12 , Port3 => Q_11 , Port2 => Q_13 , Port1 => Q_14 );

	mul18 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_11 );

	rth1 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_27, th1 => net_26, k => Q_10 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_9 );

	rth5 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_21, k => Q_8 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_7 );

	rth2 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_26, th1 => net_27, k => Q_6 );

	Body_HeatMass01 : ENTITY WORK.cth(behav)
		PORT MAP ( th1 => net_14, t0 => T0_init , c_th => Q_5 );

	Body_Rth : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , exp => -1.0 , input => Q_4 );

	Body_Rth_Half : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , kp => 0.5 , input => Q_3 );

	R2_Body_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_14, th1 => net_27, k => Q_2 );

	R1_Body_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_14, k => Q_2 );

	Tsurf_Outer == Q_22;
	Tsurf_Inner == Q_23;
	Tcenter == Q_26;
	Heat_Outer_w == Q_27;
	Heat_Inner_w == Q_28;
END ARCHITECTURE struct;
----------------------------------------------------------------------


--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Rth_Jurges_kmh10 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_kmh10;

ARCHITECTURE struct OF Rth_Jurges_kmh10 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
BEGIN
	neg1 : ENTITY WORK.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_15 , input1 => 1.0e-06 , input0 => Port1 );

	Car_Speed_mps : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 0.277777777777778 , input0 => Q_15 );

	sum2 : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY WORK.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY WORK.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input => Q_7 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , input1 => Q_12 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_10 , input0 => Q_11 );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => 7.1 , input0 => Q_8 );

	HTC2_Jurges2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY WORK.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;

ENTITY Rth_Jurges_mps10 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_mps10;

ARCHITECTURE struct OF Rth_Jurges_mps10 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
BEGIN
	neg1 : ENTITY WORK.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 1.0e-06 , input0 => Port1 );

	sum2 : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY WORK.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY WORK.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input => Q_11 );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input1 => 7.1 , input0 => Q_12 );

	HTC2_Jurges2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_10 , input0 => Q_11 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => Q_8 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY WORK.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Rth_radiation24 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation24;

ARCHITECTURE struct OF Rth_radiation24 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY WORK.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Rth_radiation23 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation23;

ARCHITECTURE struct OF Rth_radiation23 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY WORK.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Roof2 IS
	PORT (
		TERMINAL QT_Outer : THERMAL;
		TERMINAL QT_Inner : THERMAL;
		QUANTITY Body_U : IN REAL := 0.0;
		QUANTITY Body_Cp : IN REAL := 0.0;
		QUANTITY Body_Weight : IN REAL := 0.0;
		QUANTITY Body_Area : IN REAL := 0.0;
		QUANTITY T0_init : IN REAL := 0.0;
		QUANTITY Vair_mps : IN REAL := 0.0;
		QUANTITY Vcar_kmh : IN REAL := 0.0;
		QUANTITY Heat_Outer_w : OUT REAL;
		QUANTITY Heat_Inner_w : OUT REAL;
		QUANTITY Tsurf_Inner : OUT REAL;
		QUANTITY Tcenter : OUT REAL;
		QUANTITY Tsurf_Outer : OUT REAL;
		QUANTITY HSTEP : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Roof2;

ARCHITECTURE struct OF Roof2 IS
	TERMINAL net_20 : THERMAL;
	TERMINAL net_14 : THERMAL;
	TERMINAL net_27 : THERMAL;
	TERMINAL net_26 : THERMAL;
	TERMINAL net_21 : THERMAL;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
	QUANTITY Q_16 : real := 0.0;
	QUANTITY Q_17 : real := 0.0;
	QUANTITY Q_18 : real := 0.0;
	QUANTITY Q_19 : real := 0.0;
	QUANTITY Q_20 : real := 0.0;
	QUANTITY Q_21 : real := 0.0;
	QUANTITY Q_22 : real := 0.0;
	QUANTITY Q_23 : real := 0.0;
	QUANTITY Q_24 : real := 0.0;
	QUANTITY Q_25 : real := 0.0;
	QUANTITY Q_26 : real := 0.0;
	QUANTITY Q_27 : real := 0.0;
	QUANTITY Q_28 : real := 0.0;
BEGIN
	tfm2 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_26, th1 => QT_Inner, heat => Q_28 );

	tfm1 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => QT_Outer, th1 => net_21, heat => Q_27 );

	thm3 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_27, temp => Q_23 );

	thm1 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_14, temp => Q_26 );

	thm2 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_20, temp => Q_22 );

	thm4 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Outer, temp => Q_21 );

	thm5 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Inner, temp => Q_15 );

	SubSheet3: ENTITY WORK.Rth_Jurges_kmh10(struct)
		PORT MAP ( Port3 => Q_25 , Port1 => Vcar_kmh , Port2 => Q_9 );

	SubSheet4: ENTITY WORK.Rth_Jurges_mps10(struct)
		PORT MAP ( Port3 => Q_24 , Port1 => Vair_mps , Port2 => Q_7 );

	Body_HeatMass : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Body_Weight , input0 => Body_Cp );

	mul68 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Body_Area -- Expression
		, input0 => Body_U );

	memory4 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_14 , input => Q_23 );

	memory1 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_19 , input => Q_22 );

	memory2 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_20 , input => Q_21 );

	SubSheet2: ENTITY WORK.Rth_radiation24(struct)
		PORT MAP ( Port4 => Q_18 , Port3 => Q_17 , Port2 => Q_19 , Port1 => Q_20 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_16 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_17 );

	rth4 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_21, th1 => net_20, k => Q_16 );

	memory3 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_13 , input => Q_15 );

	SubSheet1: ENTITY WORK.Rth_radiation23(struct)
		PORT MAP ( Port4 => Q_12 , Port3 => Q_11 , Port2 => Q_13 , Port1 => Q_14 );

	mul18 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_11 );

	rth1 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_27, th1 => net_26, k => Q_10 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_9 );

	rth5 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_21, k => Q_8 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_7 );

	rth2 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_26, th1 => net_27, k => Q_6 );

	Body_HeatMass01 : ENTITY WORK.cth(behav)
		PORT MAP ( th1 => net_14, t0 => T0_init , c_th => Q_5 );

	Body_Rth : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , exp => -1.0 , input => Q_4 );

	Body_Rth_Half : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , kp => 0.5 , input => Q_3 );

	R2_Body_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_14, th1 => net_27, k => Q_2 );

	R1_Body_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_14, k => Q_2 );

	Tsurf_Outer == Q_22;
	Tsurf_Inner == Q_23;
	Tcenter == Q_26;
	Heat_Outer_w == Q_27;
	Heat_Inner_w == Q_28;
END ARCHITECTURE struct;
----------------------------------------------------------------------


--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Rth_Jurges_kmh15 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_kmh15;

ARCHITECTURE struct OF Rth_Jurges_kmh15 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
BEGIN
	neg1 : ENTITY WORK.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_15 , input1 => 1.0e-06 , input0 => Port1 );

	Car_Speed_mps : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 0.277777777777778 , input0 => Q_15 );

	sum2 : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY WORK.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY WORK.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input => Q_7 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , input1 => Q_12 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_10 , input0 => Q_11 );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => 7.1 , input0 => Q_8 );

	HTC2_Jurges2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY WORK.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;

ENTITY Rth_Jurges_mps15 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_mps15;

ARCHITECTURE struct OF Rth_Jurges_mps15 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
BEGIN
	neg1 : ENTITY WORK.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 1.0e-06 , input0 => Port1 );

	sum2 : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY WORK.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY WORK.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input => Q_11 );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input1 => 7.1 , input0 => Q_12 );

	HTC2_Jurges2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_10 , input0 => Q_11 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => Q_8 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY WORK.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Rth_radiation33 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation33;

ARCHITECTURE struct OF Rth_radiation33 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY WORK.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Rth_radiation32 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation32;

ARCHITECTURE struct OF Rth_radiation32 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY WORK.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY WORK.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY WORK.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY Roof3 IS
	PORT (
		TERMINAL QT_Outer : THERMAL;
		TERMINAL QT_Inner : THERMAL;
		QUANTITY Body_U : IN REAL := 0.0;
		QUANTITY Body_Cp : IN REAL := 0.0;
		QUANTITY Body_Weight : IN REAL := 0.0;
		QUANTITY Body_Area : IN REAL := 0.0;
		QUANTITY T0_init : IN REAL := 0.0;
		QUANTITY Vair_mps : IN REAL := 0.0;
		QUANTITY Vcar_kmh : IN REAL := 0.0;
		QUANTITY Heat_Outer_w : OUT REAL;
		QUANTITY Heat_Inner_w : OUT REAL;
		QUANTITY Tsurf_Inner : OUT REAL;
		QUANTITY Tcenter : OUT REAL;
		QUANTITY Tsurf_Outer : OUT REAL;
		QUANTITY HSTEP : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Roof3;

ARCHITECTURE struct OF Roof3 IS
	TERMINAL net_20 : THERMAL;
	TERMINAL net_14 : THERMAL;
	TERMINAL net_27 : THERMAL;
	TERMINAL net_26 : THERMAL;
	TERMINAL net_21 : THERMAL;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
	QUANTITY Q_16 : real := 0.0;
	QUANTITY Q_17 : real := 0.0;
	QUANTITY Q_18 : real := 0.0;
	QUANTITY Q_19 : real := 0.0;
	QUANTITY Q_20 : real := 0.0;
	QUANTITY Q_21 : real := 0.0;
	QUANTITY Q_22 : real := 0.0;
	QUANTITY Q_23 : real := 0.0;
	QUANTITY Q_24 : real := 0.0;
	QUANTITY Q_25 : real := 0.0;
	QUANTITY Q_26 : real := 0.0;
	QUANTITY Q_27 : real := 0.0;
	QUANTITY Q_28 : real := 0.0;
BEGIN
	tfm2 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_26, th1 => QT_Inner, heat => Q_28 );

	tfm1 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => QT_Outer, th1 => net_21, heat => Q_27 );

	thm3 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_27, temp => Q_23 );

	thm1 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_14, temp => Q_26 );

	thm2 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_20, temp => Q_22 );

	thm4 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Outer, temp => Q_21 );

	thm5 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Inner, temp => Q_15 );

	SubSheet3: ENTITY WORK.Rth_Jurges_kmh15(struct)
		PORT MAP ( Port3 => Q_25 , Port1 => Vcar_kmh , Port2 => Q_9 );

	SubSheet4: ENTITY WORK.Rth_Jurges_mps15(struct)
		PORT MAP ( Port3 => Q_24 , Port1 => Vair_mps , Port2 => Q_7 );

	Body_HeatMass : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Body_Weight , input0 => Body_Cp );

	mul68 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Body_Area -- Expression
		, input0 => Body_U );

	memory4 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_14 , input => Q_23 );

	memory1 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_19 , input => Q_22 );

	memory2 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_20 , input => Q_21 );

	SubSheet2: ENTITY WORK.Rth_radiation33(struct)
		PORT MAP ( Port4 => Q_18 , Port3 => Q_17 , Port2 => Q_19 , Port1 => Q_20 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_16 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_17 );

	rth4 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_21, th1 => net_20, k => Q_16 );

	memory3 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_13 , input => Q_15 );

	SubSheet1: ENTITY WORK.Rth_radiation32(struct)
		PORT MAP ( Port4 => Q_12 , Port3 => Q_11 , Port2 => Q_13 , Port1 => Q_14 );

	mul18 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_11 );

	rth1 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_27, th1 => net_26, k => Q_10 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_9 );

	rth5 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_21, k => Q_8 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_7 );

	rth2 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_26, th1 => net_27, k => Q_6 );

	Body_HeatMass01 : ENTITY WORK.cth(behav)
		PORT MAP ( th1 => net_14, t0 => T0_init , c_th => Q_5 );

	Body_Rth : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , exp => -1.0 , input => Q_4 );

	Body_Rth_Half : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , kp => 0.5 , input => Q_3 );

	R2_Body_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_14, th1 => net_27, k => Q_2 );

	R1_Body_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_14, k => Q_2 );

	Tsurf_Outer == Q_22;
	Tsurf_Inner == Q_23;
	Tcenter == Q_26;
	Heat_Outer_w == Q_27;
	Heat_Inner_w == Q_28;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Negator                                                  --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
ENTITY NEG IS
    GENERIC(TS : REAL := 0.0);
    PORT (QUANTITY INPUT : IN REAL;
          QUANTITY VAL : OUT REAL);
END ENTITY NEG;
ARCHITECTURE behav OF NEG IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
	temp_val == -INPUT;
	VAL == temp_val'ZOH(TS);
END ARCHITECTURE;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Maximum                                                  --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MATH_REAL.ALL;

ENTITY MAX IS
    GENERIC (TS : REAL := 0.0);
    PORT (QUANTITY INPUT0,INPUT1 : IN REAL;
          QUANTITY VAL : OUT REAL);
END ENTITY MAX;
ARCHITECTURE behav OF MAX IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
  temp_val == REALMAX(INPUT0,INPUT1);
  VAL == temp_val'ZOH(TS);
END behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Summation                                                --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
ENTITY SUM IS
    GENERIC (TS : REAL := 0.0);
    PORT (QUANTITY INPUT0,INPUT1 : IN REAL;
          QUANTITY VAL : OUT REAL);
END ENTITY SUM;
ARCHITECTURE behav OF SUM IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
  temp_val == INPUT0 + INPUT1;
  VAL == temp_val'ZOH(TS);
END behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Sign                                                     --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MATH_REAL.ALL;

ENTITY sign IS
    GENERIC (TS : REAL := 0.0); 
    PORT (QUANTITY INPUT : IN REAL;
          QUANTITY AMPL : IN REAL := 1.0;
          QUANTITY VAL : OUT REAL);
END ENTITY sign;
ARCHITECTURE behav OF sign IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
  IF (INPUT >= 0.0) USE
    temp_val == AMPL;
  ELSE
    temp_val == -AMPL;
  END USE;
  VAL == temp_val'ZOH(TS);
END behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

--  --------------------------------------------------------------------------
--                                                                      --
-- Copyright (c) 2004 by ANSOFT Corp.  All rights reserved.             --
--                                                                      --
-- This source file may be used and distributed without restriction     --
-- provided that this copyright statement is not removed from the file  --
-- and that any derivative work contains this copyright notice.         --
--                                                                      --
-- Model name: Reciprocal Value                                         --
-- Library: Basic_VHDLAMS                                               --
--                                                                      --
-- ----------------------------------------------------------------------------
--                 Warranty
-- ----------------------------------------------------------------------------
-- ANSOFT Corporation makes no warranty of any kind with regard to the use of
-- this Software, either expressed or implied, including, but not limited to 
-- the fitness for a particular purpose.
-- 
-- ----------------------------------------------------------------------------
-- Modification History : 
-- ----------------------------------------------------------------------------
-- Version No:|Auth:| Mod.Date:| Changes Made:
--            |     |          | 
-- ----------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.MATH_REAL.ALL;

ENTITY fktres IS
    GENERIC (TS : REAL := 0.0);
    PORT (QUANTITY INPUT : IN REAL;
          QUANTITY VAL : OUT REAL);
END ENTITY fktres;
ARCHITECTURE behav OF fktres IS
  QUANTITY temp_val : REAL := 0.0;
BEGIN
  IF (INPUT = 0.0) USE
	temp_val == 0.0;
  ELSE
	temp_val == (1.0/INPUT);
  END USE;
  VAL == temp_val'ZOH(TS);
END behav;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_Jurges_kmh16 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_kmh16;

ARCHITECTURE struct OF Rth_Jurges_kmh16 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
BEGIN
	neg1 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_15 , input1 => 1.0e-06 , input0 => Port1 );

	Car_Speed_mps : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 0.277777777777778 , input0 => Q_15 );

	sum2 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY basic_vhdlams.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input => Q_7 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , input1 => Q_12 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_10 , input0 => Q_11 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => 7.1 , input0 => Q_8 );

	HTC2_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_Jurges_mps16 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_mps16;

ARCHITECTURE struct OF Rth_Jurges_mps16 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
BEGIN
	neg1 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 1.0e-06 , input0 => Port1 );

	sum2 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY basic_vhdlams.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input => Q_11 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input1 => 7.1 , input0 => Q_12 );

	HTC2_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_10 , input0 => Q_11 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => Q_8 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_radiation34 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation34;

ARCHITECTURE struct OF Rth_radiation34 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_radiation35 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation35;

ARCHITECTURE struct OF Rth_radiation35 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Roof4 IS
	PORT (
		TERMINAL QT_Outer : THERMAL;
		TERMINAL QT_Inner : THERMAL;
		QUANTITY Body_U : IN REAL := 0.0;
		QUANTITY Body_Cp : IN REAL := 0.0;
		QUANTITY Body_Weight : IN REAL := 0.0;
		QUANTITY Body_Area : IN REAL := 0.0;
		QUANTITY T0_init : IN REAL := 0.0;
		QUANTITY Vair_mps : IN REAL := 0.0;
		QUANTITY Vcar_kmh : IN REAL := 0.0;
		QUANTITY Heat_Outer_w : OUT REAL;
		QUANTITY Heat_Inner_w : OUT REAL;
		QUANTITY Tsurf_Inner : OUT REAL;
		QUANTITY Tcenter : OUT REAL;
		QUANTITY Tsurf_Outer : OUT REAL;
		QUANTITY Hstep : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Roof4;
ARCHITECTURE struct OF Roof4 IS
	TERMINAL net_20 : THERMAL;
	TERMINAL net_14 : THERMAL;
	TERMINAL net_27 : THERMAL;
	TERMINAL net_26 : THERMAL;
	TERMINAL net_21 : THERMAL;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
	QUANTITY Q_16 : real := 0.0;
	QUANTITY Q_17 : real := 0.0;
	QUANTITY Q_18 : real := 0.0;
	QUANTITY Q_19 : real := 0.0;
	QUANTITY Q_20 : real := 0.0;
	QUANTITY Q_21 : real := 0.0;
	QUANTITY Q_22 : real := 0.0;
	QUANTITY Q_23 : real := 0.0;
	QUANTITY Q_24 : real := 0.0;
	QUANTITY Q_25 : real := 0.0;
	QUANTITY Q_26 : real := 0.0;
	QUANTITY Q_27 : real := 0.0;
	QUANTITY Q_28 : real := 0.0;
BEGIN
	tfm2 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_26, th1 => QT_Inner, heat => Q_28 );

	tfm1 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => QT_Outer, th1 => net_21, heat => Q_27 );

	thm3 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_27, temp => Q_23 );

	thm1 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_14, temp => Q_26 );

	thm2 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_20, temp => Q_22 );

	thm4 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Outer, temp => Q_21 );

	thm5 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Inner, temp => Q_15 );

	SubSheet3: ENTITY WORK.Rth_Jurges_kmh16(struct)
		PORT MAP ( Port3 => Q_25 , Port1 => Vcar_kmh , Port2 => Q_9 );

	SubSheet4: ENTITY WORK.Rth_Jurges_mps16(struct)
		PORT MAP ( Port3 => Q_24 , Port1 => Vair_mps , Port2 => Q_7 );

	Body_HeatMass : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Body_Weight , input0 => Body_Cp );

	mul68 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Body_Area -- Expression
		, input0 => Body_U );

	memory4 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => Hstep , y0 => 273.15 )
		PORT MAP ( val => Q_14 , input => Q_23 );

	memory1 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => Hstep , y0 => 273.15 )
		PORT MAP ( val => Q_19 , input => Q_22 );

	memory2 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => Hstep , y0 => 273.15 )
		PORT MAP ( val => Q_20 , input => Q_21 );

	SubSheet2: ENTITY WORK.Rth_radiation34(struct)
		PORT MAP ( Port4 => Q_18 , Port3 => Q_17 , Port2 => Q_19 , Port1 => Q_20 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_16 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_17 );

	rth4 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_21, th1 => net_20, k => Q_16 );

	memory3 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => Hstep , y0 => 273.15 )
		PORT MAP ( val => Q_13 , input => Q_15 );

	SubSheet1: ENTITY WORK.Rth_radiation35(struct)
		PORT MAP ( Port4 => Q_12 , Port3 => Q_11 , Port2 => Q_13 , Port1 => Q_14 );

	mul18 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_11 );

	rth1 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_27, th1 => net_26, k => Q_10 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_9 );

	rth5 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_21, k => Q_8 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_7 );

	rth2 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_26, th1 => net_27, k => Q_6 );

	Body_HeatMass01 : ENTITY WORK.cth(behav)
		PORT MAP ( th1 => net_14, t0 => T0_init , c_th => Q_5 );

	Body_Rth : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , exp => -1.0 , input => Q_4 );

	Body_Rth_Half : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , kp => 0.5 , input => Q_3 );

	R2_Body_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_14, th1 => net_27, k => Q_2 );

	R1_Body_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_14, k => Q_2 );

	Tsurf_Outer == Q_22;
	Tsurf_Inner == Q_23;
	Tcenter == Q_26;
	Heat_Outer_w == Q_27;
	Heat_Inner_w == Q_28;
END ARCHITECTURE struct;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_Jurges_kmh7 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_kmh7;

ARCHITECTURE struct OF Rth_Jurges_kmh7 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
BEGIN
	neg1 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_15 , input1 => 1.0e-06 , input0 => Port1 );

	Car_Speed_mps : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 0.277777777777778 , input0 => Q_15 );

	sum2 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY basic_vhdlams.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input => Q_7 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , input1 => Q_12 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_10 , input0 => Q_11 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => 7.1 , input0 => Q_8 );

	HTC2_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_Jurges_mps7 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_mps7;

ARCHITECTURE struct OF Rth_Jurges_mps7 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
BEGIN
	neg1 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 1.0e-06 , input0 => Port1 );

	sum2 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY basic_vhdlams.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input => Q_11 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input1 => 7.1 , input0 => Q_12 );

	HTC2_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_10 , input0 => Q_11 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => Q_8 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_radiation17 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation17;

ARCHITECTURE struct OF Rth_radiation17 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Roof1 IS
	PORT (
		TERMINAL QT_Outer : THERMAL;
		TERMINAL QT_Inner : THERMAL;
		QUANTITY Body_U : IN REAL := 0.0;
		QUANTITY Body_Cp : IN REAL := 0.0;
		QUANTITY Body_Weight : IN REAL := 0.0;
		QUANTITY Body_Area : IN REAL := 0.0;
		QUANTITY T0_init : IN REAL := 0.0;
		QUANTITY Vair_mps : IN REAL := 0.0;
		QUANTITY Vcar_kmh : IN REAL := 0.0;
		QUANTITY Heat_Outer_w : OUT REAL;
		QUANTITY Heat_Inner_w : OUT REAL;
		QUANTITY Tsurf_Inner : OUT REAL;
		QUANTITY Tcenter : OUT REAL;
		QUANTITY Tsurf_Outer : OUT REAL;
		QUANTITY Hstep : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Roof1;

ARCHITECTURE struct OF Roof1 IS
	TERMINAL net_20 : THERMAL;
	TERMINAL net_14 : THERMAL;
	TERMINAL net_27 : THERMAL;
	TERMINAL net_26 : THERMAL;
	TERMINAL net_21 : THERMAL;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
	QUANTITY Q_16 : real := 0.0;
	QUANTITY Q_17 : real := 0.0;
	QUANTITY Q_18 : real := 0.0;
	QUANTITY Q_19 : real := 0.0;
	QUANTITY Q_20 : real := 0.0;
	QUANTITY Q_21 : real := 0.0;
	QUANTITY Q_22 : real := 0.0;
	QUANTITY Q_23 : real := 0.0;
	QUANTITY Q_24 : real := 0.0;
	QUANTITY Q_25 : real := 0.0;
	QUANTITY Q_26 : real := 0.0;
	QUANTITY Q_27 : real := 0.0;
	QUANTITY Q_28 : real := 0.0;
BEGIN
	tfm2 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_26, th1 => QT_Inner, heat => Q_28 );

	tfm1 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => QT_Outer, th1 => net_21, heat => Q_27 );

	thm3 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_27, temp => Q_23 );

	thm1 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_14, temp => Q_26 );

	thm2 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_20, temp => Q_22 );

	thm4 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Outer, temp => Q_21 );

	thm5 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Inner, temp => Q_15 );

	SubSheet3: ENTITY WORK.Rth_Jurges_kmh7(struct)
		PORT MAP ( Port3 => Q_25 , Port1 => Vcar_kmh , Port2 => Q_9 );

	SubSheet4: ENTITY WORK.Rth_Jurges_mps7(struct)
		PORT MAP ( Port3 => Q_24 , Port1 => Vair_mps , Port2 => Q_7 );

	Body_HeatMass : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Body_Weight , input0 => Body_Cp );

	mul68 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Body_Area -- Expression
		, input0 => Body_U );

	memory4 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => Hstep , y0 => 273.15 )
		PORT MAP ( val => Q_14 , input => Q_23 );

	memory1 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => Hstep , y0 => 273.15 )
		PORT MAP ( val => Q_19 , input => Q_22 );

	memory2 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => Hstep , y0 => 273.15 )
		PORT MAP ( val => Q_20 , input => Q_21 );

	SubSheet2: ENTITY WORK.Rth_radiation17(struct)
		PORT MAP ( Port4 => Q_18 , Port3 => Q_17 , Port2 => Q_19 , Port1 => Q_20 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_16 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_17 );

	rth4 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_21, th1 => net_20, k => Q_16 );

	memory3 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => Hstep , y0 => 273.15 )
		PORT MAP ( val => Q_13 , input => Q_15 );

	SubSheet1: ENTITY WORK.Rth_radiation17(struct)
		PORT MAP ( Port4 => Q_12 , Port3 => Q_11 , Port2 => Q_13 , Port1 => Q_14 );

	mul18 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_11 );

	rth1 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_27, th1 => net_26, k => Q_10 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_9 );

	rth5 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_21, k => Q_8 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => 1.0/Body_Area -- Expression
		, input0 => Q_7 );

	rth2 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_26, th1 => net_27, k => Q_6 );

	Body_HeatMass01 : ENTITY WORK.cth(behav)
		PORT MAP ( th1 => net_14, t0 => T0_init , c_th => Q_5 );

	Body_Rth : ENTITY WORK.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , exp => -1.0 , input => Q_4 );

	Body_Rth_Half : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , kp => 0.5 , input => Q_3 );

	R2_Body_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_14, th1 => net_27, k => Q_2 );

	R1_Body_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_14, k => Q_2 );

	Tsurf_Outer == Q_22;
	Tsurf_Inner == Q_23;
	Tcenter == Q_26;
	Heat_Outer_w == Q_27;
	Heat_Inner_w == Q_28;
END ARCHITECTURE struct;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_radiation18 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation18;

ARCHITECTURE struct OF Rth_radiation18 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY RRL_Side_Glass IS
	PORT (
		TERMINAL QT_Outer : THERMAL;
		TERMINAL QT_Inner : THERMAL;
		QUANTITY Glass_Density : IN REAL := 0.0;
		QUANTITY Glass_Cp : IN REAL := 0.0;
		QUANTITY Glass_Thickness : IN REAL := 0.0;
		QUANTITY Glass_Ramda : IN REAL := 0.0;
		QUANTITY Glass_Area : IN REAL := 0.0;
		QUANTITY T0_init : IN REAL := 0.0;
		QUANTITY Vair_mps : IN REAL := 0.0;
		QUANTITY Vcar_kmh : IN REAL := 0.0;
		QUANTITY Heat_Outer_w : OUT REAL;
		QUANTITY Heat_Inner_w : OUT REAL;
		QUANTITY Tsurf_Inner : OUT REAL;
		QUANTITY Tcenter : OUT REAL;
		QUANTITY Tsurf_Outer : OUT REAL;
		QUANTITY HSTEP : IN REAL := 0.0 
	);
BEGIN 
END ENTITY RRL_Side_Glass;

ARCHITECTURE struct OF RRL_Side_Glass IS
	TERMINAL net_14 : THERMAL;
	TERMINAL net_26 : THERMAL;
	TERMINAL net_27 : THERMAL;
	TERMINAL net_20 : THERMAL;
	TERMINAL net_21 : THERMAL;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
	QUANTITY Q_16 : real := 0.0;
	QUANTITY Q_17 : real := 0.0;
	QUANTITY Q_18 : real := 0.0;
	QUANTITY Q_19 : real := 0.0;
	QUANTITY Q_20 : real := 0.0;
	QUANTITY Q_21 : real := 0.0;
	QUANTITY Q_22 : real := 0.0;
	QUANTITY Q_23 : real := 0.0;
	QUANTITY Q_24 : real := 0.0;
	QUANTITY Q_25 : real := 0.0;
	QUANTITY Q_26 : real := 0.0;
	QUANTITY Q_27 : real := 0.0;
	QUANTITY Q_28 : real := 0.0;
	QUANTITY Q_29 : real := 0.0;
	QUANTITY Q_30 : real := 0.0;
BEGIN
	tfm2 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_26, th1 => QT_Inner, heat => Q_30 );

	tfm1 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => QT_Outer, th1 => net_21, heat => Q_29 );

	thm3 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_27, temp => Q_24 );

	thm1 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_14, temp => Q_28 );

	thm2 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_20, temp => Q_23 );

	thm4 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Outer, temp => Q_22 );

	thm5 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Inner, temp => Q_16 );

	SubSheet3: ENTITY WORK.Rth_Jurges_kmh7(struct)
		PORT MAP ( Port3 => Q_27 , Port1 => Vcar_kmh , Port2 => Q_10 );

	SubSheet4: ENTITY WORK.Rth_Jurges_mps7(struct)
		PORT MAP ( Port3 => Q_26 , Port1 => Vair_mps , Port2 => Q_8 );

	R2_Glass_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_14, th1 => net_27, k => 1.0/(Glass_Ramda/Q_25*Glass_Area) -- Expression
		);

	R1_Glass_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_14, k => 1.0/(Glass_Ramda/Q_25*Glass_Area) -- Expression
		);

	Glass_ThickHalf : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_25 , kp => 0.5 , input => Glass_Thickness );

	mul4 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => Glass_Area -- Expression
		, input0 => Glass_Density );

	memory4 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_15 , input => Q_24 );

	memory1 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_20 , input => Q_23 );

	memory2 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_21 , input => Q_22 );

	SubSheet2: ENTITY WORK.Rth_radiation17(struct)
		PORT MAP ( Port4 => Q_19 , Port3 => Q_18 , Port2 => Q_20 , Port1 => Q_21 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_17 , input1 => 1.0/Glass_Area -- Expression
		, input0 => Q_18 );

	rth4 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_21, th1 => net_20, k => Q_17 );

	memory3 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_14 , input => Q_16 );

	SubSheet1: ENTITY WORK.Rth_radiation18(struct)
		PORT MAP ( Port4 => Q_13 , Port3 => Q_12 , Port2 => Q_14 , Port1 => Q_15 );

	mul18 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , input1 => 1.0/Glass_Area -- Expression
		, input0 => Q_12 );

	rth1 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_27, th1 => net_26, k => Q_11 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 1.0/Glass_Area -- Expression
		, input0 => Q_10 );

	rth5 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_21, k => Q_9 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0/Glass_Area -- Expression
		, input0 => Q_8 );

	rth2 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_26, th1 => net_27, k => Q_7 );

	mul22 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Glass_Thickness , input0 => Q_6 );

	Glass_Weight : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , kp => 1.0 , input => Q_5 );

	mul5 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Glass_Cp );

	Glass_HeatMass : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , kp => 1.0 , input => Q_3 );

	Glass_HeatMass01 : ENTITY WORK.cth(behav)
		PORT MAP ( th1 => net_14, t0 => T0_init , c_th => Q_2 );

	Tsurf_Outer == Q_23;
	Tsurf_Inner == Q_24;
	Tcenter == Q_28;
	Heat_Outer_w == Q_29;
	Heat_Inner_w == Q_30;
END ARCHITECTURE struct;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_Jurges_kmh8 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_kmh8;

ARCHITECTURE struct OF Rth_Jurges_kmh8 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
BEGIN
	neg1 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_15 , input1 => 1.0e-06 , input0 => Port1 );

	Car_Speed_mps : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 0.277777777777778 , input0 => Q_15 );

	sum2 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY basic_vhdlams.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input => Q_7 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , input1 => Q_12 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_10 , input0 => Q_11 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => 7.1 , input0 => Q_8 );

	HTC2_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_Jurges_mps8 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_mps8;

ARCHITECTURE struct OF Rth_Jurges_mps8 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
BEGIN
	neg1 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 1.0e-06 , input0 => Port1 );

	sum2 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY basic_vhdlams.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input => Q_11 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input1 => 7.1 , input0 => Q_12 );

	HTC2_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_10 , input0 => Q_11 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => Q_8 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_radiation14 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation14;

ARCHITECTURE struct OF Rth_radiation14 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_radiation13 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation13;

ARCHITECTURE struct OF Rth_radiation13 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY WS_Glass IS
	PORT (
		TERMINAL QT_Outer : THERMAL;
		TERMINAL QT_Inner : THERMAL;
		QUANTITY Glass_Density : IN REAL := 0.0;
		QUANTITY Glass_Cp : IN REAL := 0.0;
		QUANTITY Glass_Thickness : IN REAL := 0.0;
		QUANTITY Glass_Ramda : IN REAL := 0.0;
		QUANTITY Glass_Area : IN REAL := 0.0;
		QUANTITY T0_init : IN REAL := 0.0;
		QUANTITY Vair_mps : IN REAL := 0.0;
		QUANTITY Vcar_kmh : IN REAL := 0.0;
		QUANTITY Heat_Outer_w : OUT REAL;
		QUANTITY Heat_Inner_w : OUT REAL;
		QUANTITY Tsurf_Inner : OUT REAL;
		QUANTITY Tcenter : OUT REAL;
		QUANTITY Tsurf_Outer : OUT REAL;
		QUANTITY HSTEP : IN REAL := 0.0 
	);
BEGIN 
END ENTITY WS_Glass;

ARCHITECTURE struct OF WS_Glass IS
	TERMINAL net_14 : THERMAL;
	TERMINAL net_26 : THERMAL;
	TERMINAL net_27 : THERMAL;
	TERMINAL net_20 : THERMAL;
	TERMINAL net_21 : THERMAL;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
	QUANTITY Q_16 : real := 0.0;
	QUANTITY Q_17 : real := 0.0;
	QUANTITY Q_18 : real := 0.0;
	QUANTITY Q_19 : real := 0.0;
	QUANTITY Q_20 : real := 0.0;
	QUANTITY Q_21 : real := 0.0;
	QUANTITY Q_22 : real := 0.0;
	QUANTITY Q_23 : real := 0.0;
	QUANTITY Q_24 : real := 0.0;
	QUANTITY Q_25 : real := 0.0;
	QUANTITY Q_26 : real := 0.0;
	QUANTITY Q_27 : real := 0.0;
	QUANTITY Q_28 : real := 0.0;
	QUANTITY Q_29 : real := 0.0;
	QUANTITY Q_30 : real := 0.0;
BEGIN
	tfm2 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_26, th1 => QT_Inner, heat => Q_30 );

	tfm1 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => QT_Outer, th1 => net_21, heat => Q_29 );

	thm3 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_27, temp => Q_24 );

	thm1 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_14, temp => Q_28 );

	thm2 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_20, temp => Q_23 );

	thm4 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Outer, temp => Q_22 );

	thm5 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Inner, temp => Q_16 );

	SubSheet3: ENTITY WORK.Rth_Jurges_kmh8(struct)
		PORT MAP ( Port3 => Q_27 , Port1 => Vcar_kmh , Port2 => Q_10 );

	SubSheet4: ENTITY WORK.Rth_Jurges_mps8(struct)
		PORT MAP ( Port3 => Q_26 , Port1 => Vair_mps , Port2 => Q_8 );

	R2_Glass_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_14, th1 => net_27, k => 1.0/(Glass_Ramda/Q_25*Glass_Area) -- Expression
		);

	R1_Glass_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_14, k => 1.0/(Glass_Ramda/Q_25*Glass_Area) -- Expression
		);

	Glass_ThickHalf : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_25 , kp => 0.5 , input => Glass_Thickness );

	mul4 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => Glass_Area -- Expression
		, input0 => Glass_Density );

	memory4 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_15 , input => Q_24 );

	memory1 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_20 , input => Q_23 );

	memory2 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_21 , input => Q_22 );

	SubSheet2: ENTITY WORK.Rth_radiation14(struct)
		PORT MAP ( Port4 => Q_19 , Port3 => Q_18 , Port2 => Q_20 , Port1 => Q_21 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_17 , input1 => 1.0/Glass_Area -- Expression
		, input0 => Q_18 );

	rth4 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_21, th1 => net_20, k => Q_17 );

	memory3 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_14 , input => Q_16 );

	SubSheet1: ENTITY WORK.Rth_radiation13(struct)
		PORT MAP ( Port4 => Q_13 , Port3 => Q_12 , Port2 => Q_14 , Port1 => Q_15 );

	mul18 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , input1 => 1.0/Glass_Area -- Expression
		, input0 => Q_12 );

	rth1 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_27, th1 => net_26, k => Q_11 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 1.0/Glass_Area -- Expression
		, input0 => Q_10 );

	rth5 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_21, k => Q_9 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0/Glass_Area -- Expression
		, input0 => Q_8 );

	rth2 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_26, th1 => net_27, k => Q_7 );

	mul22 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Glass_Thickness , input0 => Q_6 );

	Glass_Weight : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , kp => 1.0 , input => Q_5 );

	mul5 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Glass_Cp );

	Glass_HeatMass : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , kp => 1.0 , input => Q_3 );

	Glass_HeatMass01 : ENTITY WORK.cth(behav)
		PORT MAP ( th1 => net_14, t0 => T0_init , c_th => Q_2 );

	Tsurf_Outer == Q_23;
	Tsurf_Inner == Q_24;
	Tcenter == Q_28;
	Heat_Outer_w == Q_29;
	Heat_Inner_w == Q_30;
END ARCHITECTURE struct;
--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_Jurges_kmh11 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_kmh11;

ARCHITECTURE struct OF Rth_Jurges_kmh11 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
BEGIN
	neg1 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_15 , input1 => 1.0e-06 , input0 => Port1 );

	Car_Speed_mps : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 0.277777777777778 , input0 => Q_15 );

	sum2 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY basic_vhdlams.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input => Q_7 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , input1 => Q_12 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_10 , input0 => Q_11 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => 7.1 , input0 => Q_8 );

	HTC2_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_Jurges_mps11 IS
	PORT (
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port1 : IN REAL := 0.0;
		QUANTITY Port2 : OUT REAL 
	);
BEGIN 
END ENTITY Rth_Jurges_mps11;

ARCHITECTURE struct OF Rth_Jurges_mps11 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
BEGIN
	neg1 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_14 , input => 5.0 );

	max2 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 1.0e-06 , input0 => Port1 );

	sum2 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_13 , input1 => Q_9 , input0 => Q_14 );

	sign1 : ENTITY basic_vhdlams.sign(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , ampl => 1.0 , input => Q_13 );

	neg2 : ENTITY basic_vhdlams.neg(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input => Q_11 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_12 , exp => 0.78 , input => Q_9 );

	HTC2_Jurges : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_10 , input1 => 7.1 , input0 => Q_12 );

	HTC2_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => Q_10 , input0 => Q_11 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => Q_9 , input0 => 3.94 );

	HTC1_Jurges : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => Q_8 , input0 => 5.57 );

	HTC1_Jurges2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Q_6 , input0 => Q_7 );

	HTC_Jurges_Result : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Q_5 );

	Rth_Jurges_Result : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port2 == Q_2;
	Port3 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_radiation25 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation25;

ARCHITECTURE struct OF Rth_radiation25 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY Rth_radiation26 IS
	PORT (
		QUANTITY Port4 : OUT REAL;
		QUANTITY Port3 : OUT REAL;
		QUANTITY Port2 : IN REAL := 0.0;
		QUANTITY Port1 : IN REAL := 0.0 
	);
BEGIN 
END ENTITY Rth_radiation26;

ARCHITECTURE struct OF Rth_radiation26 IS
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
BEGIN
	sum3 : ENTITY basic_vhdlams.sum(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => Port1 , input0 => Port2 );

	mul1 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_8 , input1 => 0.5 , input0 => Q_9 );

	max1 : ENTITY basic_vhdlams.max(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0e-06 , input0 => Q_8 );

	pow1 : ENTITY basic_vhdlams.pow(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , exp => 3.0 , input => Q_7 );

	mul2 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => 4.0 , input0 => Q_6 );

	mul3 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , input1 => 5.670367e-08 , input0 => Q_5 );

	mul4 : ENTITY basic_vhdlams.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => 0.9 , input0 => Q_4 );

	fktres1 : ENTITY basic_vhdlams.fktres(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , input => Q_3 );

	Port3 == Q_2;
	Port4 == Q_3;
END ARCHITECTURE struct;

--//////////////////////////////////////////////////////////////////////////////////////////////////

--///////////////////////////////////////////////////////////////////////////////////////////////////

----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;
LIBRARY basic_vhdlams;

ENTITY RR_Glass IS
	PORT (
		TERMINAL QT_Outer : THERMAL;
		TERMINAL QT_Inner : THERMAL;
		QUANTITY Glass_Density : IN REAL := 0.0;
		QUANTITY Glass_Cp : IN REAL := 0.0;
		QUANTITY Glass_Thickness : IN REAL := 0.0;
		QUANTITY Glass_Ramda : IN REAL := 0.0;
		QUANTITY Glass_Area : IN REAL := 0.0;
		QUANTITY T0_init : IN REAL := 0.0;
		QUANTITY Vair_mps : IN REAL := 0.0;
		QUANTITY Vcar_kmh : IN REAL := 0.0;
		QUANTITY Heat_Outer_w : OUT REAL;
		QUANTITY Heat_Inner_w : OUT REAL;
		QUANTITY Tsurf_Inner : OUT REAL;
		QUANTITY Tcenter : OUT REAL;
		QUANTITY Tsurf_Outer : OUT REAL;
		QUANTITY HSTEP : IN REAL := 0.0 
	);
BEGIN 
END ENTITY RR_Glass;

ARCHITECTURE struct OF RR_Glass IS
	TERMINAL net_14 : THERMAL;
	TERMINAL net_26 : THERMAL;
	TERMINAL net_27 : THERMAL;
	TERMINAL net_20 : THERMAL;
	TERMINAL net_21 : THERMAL;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
	QUANTITY Q_16 : real := 0.0;
	QUANTITY Q_17 : real := 0.0;
	QUANTITY Q_18 : real := 0.0;
	QUANTITY Q_19 : real := 0.0;
	QUANTITY Q_20 : real := 0.0;
	QUANTITY Q_21 : real := 0.0;
	QUANTITY Q_22 : real := 0.0;
	QUANTITY Q_23 : real := 0.0;
	QUANTITY Q_24 : real := 0.0;
	QUANTITY Q_25 : real := 0.0;
	QUANTITY Q_26 : real := 0.0;
	QUANTITY Q_27 : real := 0.0;
	QUANTITY Q_28 : real := 0.0;
	QUANTITY Q_29 : real := 0.0;
	QUANTITY Q_30 : real := 0.0;
BEGIN
	tfm2 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_26, th1 => QT_Inner, heat => Q_30 );

	tfm1 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => QT_Outer, th1 => net_21, heat => Q_29 );

	thm3 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_27, temp => Q_24 );

	thm1 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_14, temp => Q_28 );

	thm2 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_20, temp => Q_23 );

	thm4 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Outer, temp => Q_22 );

	thm5 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => QT_Inner, temp => Q_16 );

	SubSheet3: ENTITY WORK.Rth_Jurges_kmh11(struct)
		PORT MAP ( Port3 => Q_27 , Port1 => Vcar_kmh , Port2 => Q_10 );

	SubSheet4: ENTITY WORK.Rth_Jurges_mps11(struct)
		PORT MAP ( Port3 => Q_26 , Port1 => Vair_mps , Port2 => Q_8 );

	R2_Glass_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_14, th1 => net_27, k => 1.0/(Glass_Ramda/Q_25*Glass_Area) -- Expression
		);

	R1_Glass_ThickHalf : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_14, k => 1.0/(Glass_Ramda/Q_25*Glass_Area) -- Expression
		);

	Glass_ThickHalf : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_25 , kp => 0.5 , input => Glass_Thickness );

	mul4 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_6 , input1 => Glass_Area -- Expression
		, input0 => Glass_Density );

	memory4 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_15 , input => Q_24 );

	memory1 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_20 , input => Q_23 );

	memory2 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_21 , input => Q_22 );

	SubSheet2: ENTITY WORK.Rth_radiation25(struct)
		PORT MAP ( Port4 => Q_19 , Port3 => Q_18 , Port2 => Q_20 , Port1 => Q_21 );

	mul1 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_17 , input1 => 1.0/Glass_Area -- Expression
		, input0 => Q_18 );

	rth4 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_21, th1 => net_20, k => Q_17 );

	memory3 : ENTITY WORK.memory(sml_behav)
		GENERIC MAP ( ts => HSTEP , y0 => 273.15 )
		PORT MAP ( val => Q_14 , input => Q_16 );

	SubSheet1: ENTITY WORK.Rth_radiation26(struct)
		PORT MAP ( Port4 => Q_13 , Port3 => Q_12 , Port2 => Q_14 , Port1 => Q_15 );

	mul18 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_11 , input1 => 1.0/Glass_Area -- Expression
		, input0 => Q_12 );

	rth1 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_27, th1 => net_26, k => Q_11 );

	mul3 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_9 , input1 => 1.0/Glass_Area -- Expression
		, input0 => Q_10 );

	rth5 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_20, th1 => net_21, k => Q_9 );

	mul2 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_7 , input1 => 1.0/Glass_Area -- Expression
		, input0 => Q_8 );

	rth2 : ENTITY WORK.rth(behav)
		PORT MAP ( th2 => net_26, th1 => net_27, k => Q_7 );

	mul22 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_5 , input1 => Glass_Thickness , input0 => Q_6 );

	Glass_Weight : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_4 , kp => 1.0 , input => Q_5 );

	mul5 : ENTITY WORK.mul(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_3 , input1 => Q_4 , input0 => Glass_Cp );

	Glass_HeatMass : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_2 , kp => 1.0 , input => Q_3 );

	Glass_HeatMass01 : ENTITY WORK.cth(behav)
		PORT MAP ( th1 => net_14, t0 => T0_init , c_th => Q_2 );

	Tsurf_Outer == Q_23;
	Tsurf_Inner == Q_24;
	Tcenter == Q_28;
	Heat_Outer_w == Q_29;
	Heat_Inner_w == Q_30;
END ARCHITECTURE struct;
--//////////////////////////////////////////////////////////////////////////////////////////////////


LIBRARY ieee;
USE ieee.all;

ENTITY CAB_PNT IS
	PORT (
		QUANTITY v_VL_PNT_mps : IN REAL := 0.0;
		QUANTITY CATH_PNT_temp_init_K : IN REAL := 0.0;
		QUANTITY CATH_PNT_room_air_v_mps : IN REAL := 0.0;
		QUANTITY P_CATH_CNT_heater_W : IN REAL := 0.0;
		QUANTITY T_CATH_PNT_K : OUT REAL 
	);
BEGIN 
END ENTITY CAB_PNT;

ARCHITECTURE struct OF CAB_PNT IS
	TERMINAL net_24 : THERMAL;
	TERMINAL net_90 : THERMAL;
	TERMINAL net_9 : THERMAL;
	TERMINAL net_79 : THERMAL;
	TERMINAL net_16 : THERMAL;
	TERMINAL net_23 : THERMAL;
	TERMINAL net_97 : THERMAL;
	TERMINAL net_3 : THERMAL;
	TERMINAL net_100 : THERMAL;
	TERMINAL net_105 : THERMAL;
	TERMINAL net_1 : THERMAL;
	TERMINAL net_146 : THERMAL;
	QUANTITY Q_2 : real := 0.0;
	QUANTITY Q_3 : real := 0.0;
	QUANTITY Q_4 : real := 0.0;
	QUANTITY Q_5 : real := 0.0;
	QUANTITY Q_6 : real := 0.0;
	QUANTITY Q_7 : real := 0.0;
	QUANTITY Q_8 : real := 0.0;
	QUANTITY Q_9 : real := 0.0;
	QUANTITY Q_10 : real := 0.0;
	QUANTITY Q_11 : real := 0.0;
	QUANTITY Q_12 : real := 0.0;
	QUANTITY Q_13 : real := 0.0;
	QUANTITY Q_14 : real := 0.0;
	QUANTITY Q_15 : real := 0.0;
	QUANTITY Q_16 : real := 0.0;
	QUANTITY Q_17 : real := 0.0;
	QUANTITY Q_18 : real := 0.0;
	QUANTITY Q_19 : real := 0.0;
	QUANTITY Q_20 : real := 0.0;
	QUANTITY Q_21 : real := 0.0;
	QUANTITY Q_22 : real := 0.0;
	QUANTITY Q_23 : real := 0.0;
	QUANTITY Q_24 : real := 0.0;
	QUANTITY Q_25 : real := 0.0;
	QUANTITY Q_26 : real := 0.0;
	QUANTITY Q_27 : real := 0.0;
	QUANTITY Q_28 : real := 0.0;
	QUANTITY Q_29 : real := 0.0;
	QUANTITY Q_30 : real := 0.0;
	QUANTITY Q_31 : real := 0.0;
	QUANTITY Q_32 : real := 0.0;
	QUANTITY Q_33 : real := 0.0;
	QUANTITY Q_34 : real := 0.0;
	QUANTITY Q_35 : real := 0.0;
	QUANTITY Q_36 : real := 0.0;
	QUANTITY Q_37 : real := 0.0;
	QUANTITY Q_38 : real := 0.0;
	QUANTITY Q_39 : real := 0.0;
	QUANTITY Q_40 : real := 0.0;
	QUANTITY Q_41 : real := 0.0;
	QUANTITY Q_42 : real := 0.0;
	QUANTITY Q_43 : real := 0.0;
	QUANTITY Q_44 : real := 0.0;
	QUANTITY Q_45 : real := 0.0;
	QUANTITY Q_46 : real := 0.0;
	QUANTITY Q_47 : real := 0.0;
	QUANTITY Q_48 : real := 0.0;
	QUANTITY Q_49 : real := 0.0;
	QUANTITY Q_50 : real := 0.0;
	QUANTITY Q_51 : real := 0.0;
	QUANTITY Q_52 : real := 0.0;
	QUANTITY Q_53 : real := 0.0;
	QUANTITY Q_54 : real := 0.0;
	QUANTITY Q_55 : real := 0.0;
	QUANTITY Q_56 : real := 0.0;
	QUANTITY Q_57 : real := 0.0;
	QUANTITY Q_58 : real := 0.0;
	QUANTITY Q_59 : real := 0.0;
	QUANTITY Q_60 : real := 0.0;
	QUANTITY Q_61 : real := 0.0;
	QUANTITY Q_62 : real := 0.0;
	QUANTITY Q_63 : real := 0.0;
	QUANTITY Q_64 : real := 0.0;
BEGIN
	WS_Heat_loss : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_79, th1 => net_16, heat => Q_64 );

	tfm2 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_90, th1 => net_23, heat => Q_63 );

	Defroster_HeatLoss : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_9, th1 => net_100, heat => Q_62 );

	Cabin_Wall_HeatLoss : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_24, th1 => net_3, heat => Q_61 );

	const6 : ENTITY WORK.const(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_49 , ac_phase => 0.0 , ac_mag => 0.001 , const => 138.0 );

	thm1 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_146, temp => Q_60 );

	thm2 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_24, temp => Q_59 );

	thm3 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_105, temp => Q_58 );

	thm4 : ENTITY WORK.thm(behav)
		PORT MAP ( th1 => net_1, temp => Q_57 );

	tfm11 : ENTITY WORK.tfm(behav)
		PORT MAP ( th2 => net_90, th1 => net_97, heat => Q_56 );

	gain1 : ENTITY WORK.gain(behav)
		GENERIC MAP ( ts => 0.0 )
		PORT MAP ( val => Q_48 , kp => 3.6 , input => v_VL_PNT_mps );

	t2 : ENTITY WORK.t(behav)
		PORT MAP ( th1 => net_79, ac_phase => 0.0 , ac_mag => 0.000999999999976353 , value => CATH_PNT_temp_init_K );

	t1 : ENTITY WORK.t(behav)
		PORT MAP ( th1 => net_90, ac_phase => 0.0 , ac_mag => 0.000999999999976353 , value => CATH_PNT_temp_init_K );

	hvac_heatcircuit : ENTITY WORK.hvac_heatcircuit(struct)
		PORT MAP ( outlet_heatloss => net_97, wall_heatloss => net_3, def_heatloss => net_100, room_temp_k => net_105, hvac_temp_k => net_1, defroster_temp_k => net_146, heaterpower_input => P_CATH_CNT_heater_W , temp_initial => CATH_PNT_temp_init_K , human_heat_w => Q_49 , outlet_loss_w => Q_50 , def_glassloss_w => Q_51 , wall_loss_w => Q_52 , hvac_to_room_w => Q_53 , hvac_to_def_w => Q_54 , def_to_room_w => Q_55 );

	q_firstorder_vda2 : ENTITY WORK.q_firstorder_vda(basic)
		GENERIC MAP ( t => 1.0 , k => 1.0 )
		PORT MAP ( q_out => Q_7 , q_in => Q_48 );

	floor : ENTITY WORK.roof(struct)
		PORT MAP ( qt_inner => net_24, qt_outer => net_90, hstep => 0.08 , tsurf_outer => Q_43 , tcenter => Q_44 , tsurf_inner => Q_45 , heat_inner_w => Q_46 , heat_outer_w => Q_47 , vcar_kmh => Q_7 , vair_mps => CATH_PNT_room_air_v_mps , t0_init => CATH_PNT_temp_init_K , body_area => 2.414 , body_weight => 19.4 , body_cp => 440.0 , body_u => 3.0 );

	FRL_RRL_Doors : ENTITY WORK.roof2(struct)
		PORT MAP ( qt_inner => net_24, qt_outer => net_90, hstep => 0.08 , tsurf_outer => Q_38 , tcenter => Q_39 , tsurf_inner => Q_40 , heat_inner_w => Q_41 , heat_outer_w => Q_42 , vcar_kmh => Q_7 , vair_mps => CATH_PNT_room_air_v_mps , t0_init => CATH_PNT_temp_init_K , body_area => 3.2287 , body_weight => 25.9 , body_cp => 440.0 , body_u => 5.0 );

	Back_Door : ENTITY WORK.roof3(struct)
		PORT MAP ( qt_inner => net_24, qt_outer => net_90, hstep => 0.08 , tsurf_outer => Q_33 , tcenter => Q_34 , tsurf_inner => Q_35 , heat_inner_w => Q_36 , heat_outer_w => Q_37 , vcar_kmh => Q_7 , vair_mps => CATH_PNT_room_air_v_mps , t0_init => CATH_PNT_temp_init_K , body_area => 0.9182 , body_weight => 7.4 , body_cp => 440.0 , body_u => 5.0 );

	Frame : ENTITY WORK.roof4(struct)
		PORT MAP ( qt_inner => net_24, qt_outer => net_90, hstep => 0.08 , tsurf_outer => Q_28 , tcenter => Q_29 , tsurf_inner => Q_30 , heat_inner_w => Q_31 , heat_outer_w => Q_32 , vcar_kmh => Q_7 , vair_mps => CATH_PNT_room_air_v_mps , t0_init => CATH_PNT_temp_init_K , body_area => 8.093 , body_weight => 220.0 , body_cp => 440.0 , body_u => 1.0 );

	Roof : ENTITY WORK.roof1(struct)
		PORT MAP ( qt_inner => net_24, qt_outer => net_23, hstep => 0.08 , tsurf_outer => Q_23 , tcenter => Q_24 , tsurf_inner => Q_25 , heat_inner_w => Q_26 , heat_outer_w => Q_27 , vcar_kmh => Q_7 , vair_mps => CATH_PNT_room_air_v_mps , t0_init => CATH_PNT_temp_init_K , body_area => 1.666 , body_weight => 13.4 , body_cp => 440.0 , body_u => 3.0 );

	rrl_side_glass1 : ENTITY WORK.rrl_side_glass(struct)
		PORT MAP ( qt_inner => net_24, qt_outer => net_90, hstep => 0.08 , tsurf_outer => Q_18 , tcenter => Q_19 , tsurf_inner => Q_20 , heat_inner_w => Q_21 , heat_outer_w => Q_22 , vcar_kmh => Q_7 , vair_mps => CATH_PNT_room_air_v_mps , t0_init => CATH_PNT_temp_init_K , glass_area => 0.5902 , glass_ramda => 1.0 , glass_thickness => 0.003 , glass_cp => 840.0 , glass_density => 2700.0 );

	ws_glass1 : ENTITY WORK.ws_glass(struct)
		PORT MAP ( qt_inner => net_9, qt_outer => net_16, hstep => 0.08 , tsurf_outer => Q_13 , tcenter => Q_14 , tsurf_inner => Q_15 , heat_inner_w => Q_16 , heat_outer_w => Q_17 , vcar_kmh => Q_7 , vair_mps => CATH_PNT_room_air_v_mps , t0_init => CATH_PNT_temp_init_K , glass_area => 1.137 , glass_ramda => 1.0 , glass_thickness => 0.005 , glass_cp => 840.0 , glass_density => 2700.0 );

	ws_glass2 : ENTITY WORK.ws_glass(struct)
		PORT MAP ( qt_inner => net_9, qt_outer => net_79, hstep => 0.08 , tsurf_outer => Q_8 , tcenter => Q_9 , tsurf_inner => Q_10 , heat_inner_w => Q_11 , heat_outer_w => Q_12 , vcar_kmh => Q_7 , vair_mps => CATH_PNT_room_air_v_mps , t0_init => CATH_PNT_temp_init_K , glass_area => 0.7606 , glass_ramda => 1.0 , glass_thickness => 0.003 , glass_cp => 840.0 , glass_density => 2700.0 );

	rr_glass1 : ENTITY WORK.rr_glass(struct)
		PORT MAP ( qt_inner => net_24, qt_outer => net_90, hstep => 0.08 , tsurf_outer => Q_2 , tcenter => Q_3 , tsurf_inner => Q_4 , heat_inner_w => Q_5 , heat_outer_w => Q_6 , vcar_kmh => Q_7 , vair_mps => CATH_PNT_room_air_v_mps , t0_init => CATH_PNT_temp_init_K , glass_area => 0.5245 , glass_ramda => 1.0 , glass_thickness => 0.005 , glass_cp => 840.0 , glass_density => 2700.0 );

	T_CATH_PNT_K == Q_58;
END ARCHITECTURE struct;
----------------------------------------------------------------------


LIBRARY ieee;
USE ieee.all;

ENTITY CATH_PNT IS
	PORT (
		TERMINAL EL_AC_PNT : ELECTRICAL;
		TERMINAL EL_BLO_PNT : ELECTRICAL;
		QUANTITY CATH_PNT_temp_init_K : IN REAL := 0.0;
		QUANTITY CATH_PNT_room_air_v_mps : IN REAL := 0.0;
		QUANTITY v_VL_PNT_mps : IN REAL := 0.0;
		QUANTITY P_CATH_CNT_heater_W : IN REAL := 0.0;
		QUANTITY T_CATH_PNT_K : OUT REAL;
		QUANTITY P_CATH_CNT_aircon_W : IN REAL := 0.0;
		QUANTITY V_BT_Hi_PNT_V : IN REAL := 0.0;
		QUANTITY P_CATH_CNT_blower_W : IN REAL := 0.0 
	);
BEGIN 
END ENTITY CATH_PNT;

ARCHITECTURE struct OF CATH_PNT IS
	QUANTITY Q_2 : real := 0.0;
BEGIN
	Blower: ENTITY WORK.BLO_PNT(struct)
		PORT MAP ( el_blo_pnt => EL_BLO_PNT, P_CATH_CNT_blower_W => P_CATH_CNT_blower_W );

	Aircon: ENTITY WORK.AC_PNT(struct)
		PORT MAP ( el_ac_pnt => EL_AC_PNT, V_BT_Hi_PNT_V => V_BT_Hi_PNT_V , P_CATH_CNT_aircon_W => P_CATH_CNT_aircon_W );

	Cabin: ENTITY WORK.CAB_PNT(struct)
		PORT MAP ( v_VL_PNT_mps => v_VL_PNT_mps , CATH_PNT_temp_init_K => CATH_PNT_temp_init_K , CATH_PNT_room_air_v_mps => CATH_PNT_room_air_v_mps , P_CATH_CNT_heater_W => P_CATH_CNT_heater_W , T_CATH_PNT_K => Q_2 );

	T_CATH_PNT_K == Q_2;
END ARCHITECTURE struct;
----------------------------------------------------------------------


